/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package kolekce;

import java.io.*;
import java.net.*;
import java.util.*;

/**
 *
 * @author balikm1
 */
public class WordReader {
    
    private List wordList = new ArrayList();
    private HashMap h;
    private Map m;
    private Word nejcetnejsi;
    private boolean modified = true;
    InputStreamReader fr;

    public WordReader(String fileName) throws FileNotFoundException, IOException
    {
        if (!(new File(fileName)).exists())
            throw new FileNotFoundException(fileName);

        fr = new InputStreamReader(new FileInputStream(fileName), "Windows-1250");
    }

    public WordReader(URL url) throws FileNotFoundException, IOException
    {
        URLConnection urlConn;
        urlConn = url.openConnection();

        fr = new InputStreamReader(urlConn.getInputStream(), "Windows-1250");
    }

    public void read() throws IOException
    {
        modified = true;

        int ci;
        StringBuilder s = new StringBuilder();
        while ((ci = fr.read()) != -1) {
            char c = (char)ci;
            if (!Character.isLetter(c))
            {
                if (s.length() > 0)
                {
                    wordList.add(new Word(s.toString()));
                    s.setLength(0);
                }
            }
            else
            {
                s.append(Character.toLowerCase(c));
            }
        }
    }

    public void close() throws IOException
    {
        fr.close();
    }

    public List getAlphabeticalOrderedWordList()
    {
        Collections.sort(wordList);
        return wordList;
    }

    public Map<Word,Integer> getFrequenceOrderedWordList()
    {
        if (m == null || modified)
        {
            m = new LinkedHashMap<Word,Integer>();
            List list = new LinkedList(getFrequenceChar().entrySet());
            Collections.sort(list, new Comparator() {
                public int compare(Object o1, Object o2) {
                    Map.Entry e1 =  ( Map.Entry ) o1;
                    Map.Entry e2 =  ( Map.Entry ) o2;

                    Integer i1 =  (Integer)e1.getValue();
                    Integer i2 =  (Integer)e2.getValue();

                    return i1.compareTo(i2);
                }
            });
            for (Iterator i = list.iterator(); i.hasNext();)
            {
                Map.Entry e = (Map.Entry)i.next();
                m.put(e.getKey(), e.getValue());
            }
        }
        return m;
    }

    public HashMap<Word,Integer> getFrequenceChar()
    {
        if (h == null || modified)
        {
            h = new HashMap();
            for (Iterator i = wordList.iterator(); i.hasNext(); )
            {
                Word w = (Word)i.next();
                if (h.containsKey(w))
                {
                    h.put(w, new Integer(((Integer)h.get(w))+1));
                }
                else
                {
                    h.put(w, new Integer(1));
                }
            }
            nejcetnejsi = null;
            modified = false;
        }
        return h;
    }

    public Word getNejcetnejsi()
    {
        if (nejcetnejsi == null || modified)
        {
            HashMap<Word,Integer> fh = getFrequenceChar();
            int cetnost = 0;
            for (Word w : fh.keySet())
            {
                int value = ((Integer)fh.get(w)).intValue();
                if (value > cetnost)
                {
                    cetnost = value;
                    nejcetnejsi = w;
                }
            }
        }
        return nejcetnejsi;
    }

    public int getCetnost(Word w)
    {
        HashMap<Word,Integer> fh = getFrequenceChar();
        return ((Integer)fh.get(w)).intValue();
    }

}
